<?php
header("Content-type: text/html; charset=utf-8");
require __DIR__ . '/vendor/autoload.php';

if (php_sapi_name() != 'cli') {
    throw new Exception('This application must be run on the command line.');
}

function getClient()
{
    $client = new Google_Client();
    $client->setApplicationName('Gmail API PHP Quickstart');
    $client->setScopes(Google_Service_Gmail::GMAIL_READONLY);
    $client->setAuthConfig('credentials.json');
    $client->setAccessType('offline');
    // Load previously authorized credentials from a file.
    $credentialsPath = 'token.json';
    if (file_exists($credentialsPath)) {
        $accessToken = json_decode(file_get_contents($credentialsPath), true);
    } else {
        // Request authorization from the user.
        $authUrl = $client->createAuthUrl();
        printf("Open the following link in your browser:\n%s\n", $authUrl);
        print 'Enter verification code: ';
        $authCode = trim(fgets(STDIN));
        // Exchange authorization code for an access token.
        $accessToken = $client->fetchAccessTokenWithAuthCode($authCode);
        // Check to see if there was an error.
        if (array_key_exists('error', $accessToken)) {
            throw new Exception(join(', ', $accessToken));
        }
        // Store the credentials to disk.
        if (!file_exists(dirname($credentialsPath))) {
            mkdir(dirname($credentialsPath), 0700, true);
        }
        file_put_contents($credentialsPath, json_encode($accessToken));
        printf("Credentials saved to %s\n", $credentialsPath);
    }
    $client->setAccessToken($accessToken);
    // Refresh the token if it's expired.
    if ($client->isAccessTokenExpired()) {
        $client->fetchAccessTokenWithRefreshToken($client->getRefreshToken());
        file_put_contents($credentialsPath, json_encode($client->getAccessToken()));
    }
    return $client;
}

function getHeader($headers, $name) {
	foreach($headers as $header) {
		if($header['name'] == $name) {
			return $header['value'];
		}
	}
}

$client = getClient();
$service = new Google_Service_Gmail($client);
$opt_param = array();
$opt_param['q'] = "is:unread label:inbox ";
$opt_param['maxResults'] = 10;

if(@$_GET['act']=="title" or @$argv[1] == "title"){
	$results = $service->users_messages->listUsersMessages("me", $opt_param);
	foreach($results as $mail){
		$message = $service->users_messages->get("me", $mail['id']);
		$headers = $message->getPayload()->getHeaders();
		$subject = getHeader($headers, 'Subject');
		echo $subject. "\n";
	}
}

elseif(@$_GET['act']=="snippet" or @$argv[1] == "snippet"){
	$threads = $service->users_threads->listUsersThreads("me", $opt_param);
	foreach ($threads as $thread) {
		echo $thread->getSnippet() . "\n";
	}
}
